import 'dart:async';
import 'dart:ffi';
import 'dart:core';

import 'package:unit_rc/UnitRC.dart';

class DartBaseClass {
  final zone = Zone.current;

  Pointer<Void> cppObjectPointer = nullptr;
  Pointer<Void> toCpp() {
    if (cppObjectPointer != nullptr) {
      return cppObjectPointer;
    } else {
      return nullptr;
    }
  }

  void notifyFieldUpdated(int index) {
    _native_notifyFieldUpdated(toCpp(), index);
  }

  static late final _native_notifyFieldUpdated = unitRCLib.lookupFunction<
      Void Function(Pointer<Void>, Int32),
      void Function(Pointer<Void>, int)
  >("UnitRC_DartBaseClass_notifyFieldUpdated");
}
